const util = require('util');

const errors = {
    80001: 'invalid face platform version',
    80002: 'invalid face platform address',     // deprecated
    80003: 'invalid face platform auth',        // un tested ?
    80101: 'invalid method to revoke',
    80201: 'break the chain',
};

const UNKNOWN_ERROR = 'unknown error';

class FacePlatformError extends Error {
    constructor (code, message) {
        super();
        this.error_code = ~~code;
        this.message = util.format('%s - %s', code, message || errors[code] || UNKNOWN_ERROR);
    }
}

module.exports = (code, message) => {
    return new FacePlatformError(code, message);
};